'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RCNodePlayer = function (_React$Component) {
    _inherits(RCNodePlayer, _React$Component);

    function RCNodePlayer() {
        _classCallCheck(this, RCNodePlayer);

        return _possibleConstructorReturn(this, (RCNodePlayer.__proto__ || Object.getPrototypeOf(RCNodePlayer)).apply(this, arguments));
    }

    _createClass(RCNodePlayer, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            var _props = this.props,
                id = _props.id,
                url = _props.url,
                width = _props.width,
                height = _props.height,
                keepScreenOn = _props.keepScreenOn,
                scaleMode = _props.scaleMode,
                bufferTime = _props.bufferTime,
                volume = _props.volume,
                autoplay = _props.autoplay,
                onRef = _props.onRef;

            var canvas = document.getElementById(id);
            if (width) {
                canvas.width = width;
            }
            if (height) {
                canvas.height = height;
            }
            if (onRef) {
                onRef(this);
            }
            window.NodePlayer.load(function () {
                _this2.player = new window.NodePlayer();
                _this2.player.setView(id);
                if (keepScreenOn) {
                    _this2.player.setKeepScreenOn();
                }
                if (scaleMode) {
                    _this2.player.setScaleMode(scaleMode);
                }
                if (bufferTime) {
                    _this2.player.setBufferTime(bufferTime);
                }
                if (volume) {
                    _this2.player.setVolume(volume);
                }
                if (autoplay) {
                    _this2.player.start(url);
                }
            });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.stop();
        }
    }, {
        key: 'start',
        value: function start(url) {
            if (this.player) {
                this.player.start(!!url ? url : this.props.url);
            }
        }
    }, {
        key: 'stop',
        value: function stop() {
            if (this.player) {
                this.player.stop();
            }
        }
    }, {
        key: 'setScaleMode',
        value: function setScaleMode(mode) {
            if (this.player) {
                this.player.setScaleMode(mode);
            }
        }
    }, {
        key: 'setVolume',
        value: function setVolume(volume) {
            if (this.player) {
                this.player.setVolume(volume);
            }
        }
    }, {
        key: 'fullscreen',
        value: function fullscreen() {
            if (this.player) {
                this.player.fullscreen();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                id = _props2.id,
                style = _props2.style;

            return _react2.default.createElement('canvas', { id: id, style: style });
        }
    }]);

    return RCNodePlayer;
}(_react2.default.Component);

exports.default = RCNodePlayer;